


#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include <windows.h>

#include <sstream>


typedef int (__stdcall* hello_world_t)(int, int);


int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR lpCmdLine, int)
{
  HMODULE h = LoadLibraryA(lpCmdLine);

  if (h == 0)
  {
    MessageBox(0, TEXT("Failed to load module."), TEXT("Error"), MB_ICONERROR);
    return -1;
  }

  hello_world_t HelloWorld = reinterpret_cast<hello_world_t>(GetProcAddress(h, "HelloWorld"));

  if (HelloWorld == nullptr)
  {
    MessageBox(0, TEXT("Function not found."), TEXT("Error"), MB_ICONERROR);
    return -1;
  }


  std::ostringstream msg;
  msg << "HelloWorld(23, 42) = " << HelloWorld(23, 42);

  MessageBoxA(0, msg.str().c_str(), "Hello World!", MB_ICONINFORMATION);

  return 0;
}
